#! /bin/sh
### BEGIN INIT INFO
# Provides:          glusterfs-server
# Required-Start:    $local_fs $remote_fs $network
# Required-Stop:     $local_fs $remote_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: GlusterFS server
# Description:       GlusterFS is a cluster filesystem. This service
#                    provides the GlusterFS server functionality which
#                    is configured via a volume spec file usually
#                    located in the /etc/glusterfs directory.
### END INIT INFO

# Author: Chris AtLee <chris@atlee.ca>
# Patched by: Matthias Albert <matthias@linux4experts.de>
# Upgraded by: Neil Wilson <neil@brightbox.co.uk>
# Slightly extended by: Christian Meder <chris@absolutegiganten.org>

PATH=/usr/sbin:/usr/bin:/sbin:/bin
DESC="GlusterFS server"
NAME=glusterfsd
DAEMON=/usr/sbin/$NAME
CONFIGFILE=/etc/glusterfs/glusterfsd.vol
LOGFILE=/var/log/glusterfs/glusterfsd.vol.log
PIDFILE=/var/run/$NAME.pid
DAEMON_ARGS="-p $PIDFILE -f $CONFIGFILE --log-file $LOGFILE"
SCRIPTNAME=/etc/init.d/glusterfs-server

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions


#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
		$DAEMON_ARGS \
		|| return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --name $NAME
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

#
# Function that provides status information about the service
#
do_status()
{
	start-stop-daemon --start --quiet --pidfile $PIDFILE --name $NAME --startas $DAEMON --test > /dev/null
	RETVAL="$?"
	if [ "$RETVAL" = 1 ]; then
            log_success_msg "$DESC is running."
            exit 0
        fi
        if [ "$RETVAL" = 0 ]; then
            log_failure_msg "$DESC is not running."
            exit 1
        else
            log_failure_msg "Couldn't determine status of $DESC."
            exit 3
        fi
}

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  #reload|force-reload)
	#
	# If do_reload() is not implemented then leave this commented out
	# and leave 'force-reload' as an alias for 'restart'.
	#
	#log_daemon_msg "Reloading $DESC" "$NAME"
	#do_reload
	#log_end_msg $?
	#;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
		# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  status)
        do_status
        ;;
  *)
	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload|status}" >&2
	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload|status}" >&2
	exit 3
	;;
esac

:
